unit tems;

interface
const
inv4t610:array [0..$3b] of byte=(
$C0,$00,$00,$00,$00,$00,$01,$00,$07,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00);

inv4t68:array [0..$3b] of byte=(
$C0,$00,$00,$00,$00,$00,$01,$00,$07,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
$00,$00,$00,$00,$00,$3A,$49,$4E,$56,$34,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00);

function Calc_Tems(imei,band:pointer):string;
function Calc_Tems_T68(imei,band:pointer):string;

implementation

uses windows,sysutils;
const
key_tab:array [0..511] of byte = (
        $C4, $24, $15, $90, $C6, $15, $BF, $FF, $4F, $74, $E3, $3F, $3B, $85, $2D, $11,
        $D0, $8B, $3A, $A6, $8A, $90, $5C, $12, $23, $11, $7E, $03, $17, $58, $4C, $C0,
        $7A, $94, $CE, $6E, $AC, $EA, $F8, $10, $7E, $88, $57, $3A, $FC, $E7, $EE, $58,
        $3E, $CE, $62, $6F, $31, $93, $3B, $49, $49, $26, $5B, $CC, $85, $D9, $B6, $99,
        $F4, $BD, $A1, $36, $7C, $66, $BF, $FA, $3D, $1A, $2A, $11, $D8, $E9, $7D, $51,
        $F8, $10, $D5, $50, $A3, $C6, $A4, $B8, $61, $90, $A9, $F0, $56, $FE, $E4, $BA,
        $C1, $84, $CD, $4B, $01, $20, $73, $41, $48, $AA, $84, $B6, $CA, $5B, $42, $24,
        $65, $7B, $98, $B0, $86, $27, $2C, $AA, $ED, $2D, $AD, $9E, $8E, $9E, $EB, $5E,
        $AD, $45, $79, $A1, $3C, $72, $53, $D8, $04, $C4, $9D, $D8, $B7, $70, $EB, $AA,
        $66, $4A, $C8, $AD, $86, $51, $AF, $DF, $21, $5C, $71, $3D, $10, $21, $99, $B0,
        $68, $F6, $4D, $19, $99, $E9, $02, $C1, $AC, $9C, $17, $FE, $BA, $D2, $27, $87,
        $36, $0B, $DB, $25, $C3, $F4, $DD, $7F, $63, $36, $9F, $18, $87, $1D, $9E, $FD,
        $D1, $36, $C6, $8B, $45, $D9, $A4, $43, $DC, $04, $CD, $43, $22, $2A, $42, $79,
        $81, $BA, $75, $E7, $BD, $B9, $89, $79, $F4, $D1, $9C, $AA, $C8, $49, $9F, $66,
        $9C, $FD, $02, $95, $AC, $AE, $EA, $43, $30, $CD, $8E, $26, $FF, $57, $03, $1D,
        $9E, $1A, $C5, $C5, $51, $42, $F6, $87, $A3, $3B, $50, $43, $9B, $50, $6F, $7C,
        $F2, $68, $1B, $0E, $58, $A9, $C6, $4E, $6C, $16, $90, $D6, $05, $4F, $0B, $67,
        $1B, $8F, $AC, $34, $5D, $0F, $83, $5B, $D7, $5B, $49, $D1, $DE, $96, $53, $A3,
        $54, $56, $03, $DB, $0B, $7E, $77, $9E, $14, $EC, $BE, $9C, $C9, $8B, $0B, $D8,
        $54, $FE, $D7, $0D, $F4, $6E, $ED, $66, $C9, $5F, $C6, $C3, $BD, $8D, $48, $2F,
        $23, $D0, $ED, $FA, $E4, $28, $48, $03, $3F, $8D, $85, $86, $17, $F1, $16, $55,
        $34, $CC, $62, $EB, $07, $14, $0F, $B4, $64, $8C, $D9, $61, $03, $8D, $25, $97,
        $6B, $7A, $28, $F2, $C8, $A3, $37, $2D, $51, $A0, $5B, $06, $D0, $0A, $63, $9E,
        $E1, $3A, $2D, $05, $13, $B5, $AE, $E5, $0E, $A5, $2C, $0E, $56, $3F, $E9, $1C,
        $C6, $2B, $C4, $78, $FB, $38, $F5, $64, $77, $AE, $CF, $D1, $F6, $B8, $2B, $C4,
        $05, $88, $8E, $33, $AA, $23, $0C, $85, $98, $C9, $D5, $BB, $48, $AA, $65, $D5,
        $1D, $AC, $1C, $FB, $19, $82, $49, $24, $6E, $8F, $F8, $04, $DE, $AF, $08, $17,
        $CE, $53, $F9, $15, $31, $66, $FB, $B2, $D8, $28, $2D, $F1, $EB, $E3, $6B, $93,
        $48, $36, $2A, $95, $DF, $F4, $40, $65, $FC, $67, $CE, $05, $EE, $79, $9A, $4F,
        $99, $12, $D4, $3F, $A8, $FB, $C5, $F7, $56, $7F, $89, $6A, $BC, $35, $A4, $8B,
        $C7, $A2, $AD, $58, $02, $85, $30, $54, $88, $C2, $C9, $3F, $CB, $8A, $79, $54,
        $82, $A4, $AC, $C6, $77, $FF, $9B, $A0, $7C, $09, $28, $88, $D2, $04, $D1, $4D
);

procedure getHash1(src1,src2:pbytearray; src1_sz,src2_sz:dword; dst:pByteArray);

var
buf: array [0..15] of byte;
i:word;

begin

fillchar(buf,sizeof(buf),0);
for i:=0 to src1_sz-1  do
        buf[i and $f]:=buf[i and $f] xor src1^[i];
for i:=0 to src2_sz-1  do
        buf[i and $f]:=buf[i and $f] xor src2^[i];
move(buf,dst^,$10);
end;



function get_key(n:byte):byte;

var
r:word;
i:dword;

begin
i:=(n xor $34) and $ff;
r:=key_tab[2*i+1] and $ff;
r:=r shl 8;
r:=r or (key_tab[2*i] and $ff);
result:=byte( (r shr 4) and $ff);
end;


procedure scramble(src,dst:pbytearray; src_sz:dword);

var
i,j:dword;
idx1,idx2:Dword;

begin

for j:=0 to 7 do
        begin
        for i:=0 to src_sz-1 do
                begin
                idx1:=(dst^[j] xor src^[i] xor $73) and $ff;
                idx2:=(dst^[(j+3) and $7] xor src^[i]) and $ff;
                dst^[j]:=key_tab[2*idx1+1] xor key_tab[2*idx2];
                end;
        end;
end;

function Calc_Tems(imei,band:pointer):string;

var
i:dword;
srcbuf:array [0..$F] of byte;
dstbuf:array [0..7] of byte;

begin
getHash1(imei,band,9{sizeof(imei)},$20{sizeof(band)},@srcbuf);
for i:=0 to 7 do
        dstbuf[i]:=get_key(i);
scramble(@srcbuf,@dstbuf,$10);
scramble(@inv4t610,@dstbuf,$3c);
result:='';
for i:=0 to 7 do
        result:=result+inttohex(dstbuf[i],2);
end;

function Calc_Tems_T68(imei,band:pointer):string;

var
i:dword;
srcbuf:array [0..$F] of byte;
dstbuf:array [0..7] of byte;

begin
getHash1(imei,band,9{sizeof(imei)},$20{sizeof(band)},@srcbuf);
for i:=0 to 7 do
        dstbuf[i]:=get_key(i);
scramble(@srcbuf,@dstbuf,$10);
scramble(@inv4t68,@dstbuf,$3c);
result:='';
for i:=0 to 7 do
        result:=result+inttohex(dstbuf[i],2);
end;

begin
end.

